<!DOCTYPE html>
<html>
  <head>
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <style>
      body {
        font-family: Arial, Helvetica, sans-serif;
      }

      /* The Modal (background) */
      .modal {
        display: none;
        /* Hidden by default */
        position: fixed;
        /* Stay in place */
        z-index: 1;
        /* Sit on top */
        padding-top: 100px;
        /* Location of the box */
        left: 0;
        top: 0;
        width: 100%;
        /* Full width */
        height: 100%;
        /* Full height */
        overflow: auto;
        /* Enable scroll if needed */
        background-color: rgb(0, 0, 0);
        /* Fallback color */
        background-color: rgba(0, 0, 0, 0.4);
        /* Black w/ opacity */
      }

      .modal.active {
        display: block;
      }

      /* Modal Content */
      .modal-content {
        background-color: #fefefe;
        margin: auto;
        padding: 20px;
        border: 1px solid #888;
        width: 80%;
      }

      /* The Close Button */
      .close {
        color: #aaaaaa;
        float: right;
        font-size: 28px;
        font-weight: bold;
      }

      .close:hover,
      .close:focus {
        color: #000;
        text-decoration: none;
        cursor: pointer;
      }
    </style>
  </head>

  <body>
    <!-- Задание: напишите класс Modal, который будет создавать объект, описывающий всплывающее окно.
    Параметры объекта:
    - id всплывающего окна;
    - классы всплывающего окна;
    - текст внутри тега p;
    
    У объекта должно быть 3 метода: 
    render, который возвращает DOM-элемент всплывающего окна с такой разметкой:
    
    <div id="idОкна" class="классыОкна">
        <div class="modal-content">
            <span class="close">&times;</span>
            <p>ТекстОкна</p>
        </div>
    </div>   
    
    openModal, который открывает окно (его нужно использовать как обработчик click для button с id="myBtn");
    closeModal - который закрывает окно при клике на крестик (span с классом close) внутри окна
    - -->

    <div id="root"></div>
    <button id="myBtn">Open Modal</button>

    <script>

      class Modal {
        constructor (id, classList, text) {
          this.id = id;
          this.classList = classList;
          this.text = text;
          this.element = null;
        }
        render () {
          this.createElement();
          this.insertModal();
          this.addCloseButtonHandler();
        }
        createElement () {
          this.element = document.createElement('div');
          this.element.classList = this.classList.join(' ');
          this.element.id = this.id;
          this.element.innerHTML = ` <div class="modal-content">
                                        <span class="close">&times;</span>
                                        <p>${this.text}</p>
                                      </div>` 
        }
        insertModal () {
          document.body.append(this.element);
        }
        openModal () {
          this.element.classList.add('active');
        }
        closeModal () {
          this.element.classList.remove('active');
        }
        addCloseButtonHandler () {
          const closeBtn = document.querySelector(`#${this.id} .close`);
          closeBtn.addEventListener('click', () => this.closeModal());
        }
      }
      const newModal = new Modal('block-modal', ['modal'], 'Hello world');
      const openBtn = document.getElementById('myBtn');
      openBtn.addEventListener('click', () => newModal.openModal());
      newModal.render();


      // class Modal {
      //   constructor(id, classList, text) {
      //     this.id = id;
      //     this.classList = classList;
      //     this.text = text;
      //     this.element = null;
      //   }
      //   render(){
      //       this.createElement();
      //       this.insertModal();
      //       this.addCloseButtonHandler()
      //   }
      //   createElement(){
      //   this.element = document.createElement('div');
      //   this.element.className = this.classList.join(' ');
      //   this.element.id = this.id;
      //   this.element.innerHTML = ` <div class="modal-content">
      //       <span class="close">&times;</span>
      //       <p>${this.text}</p>
      //   </div>`
      //   }
      //   insertModal(){
      //   document.body.append(this.element)
      //   }
      //   openModal(){
      //       this.element.classList.add('active');
      //   }
      //   closeModal(){
      //       this.element.classList.remove('active');
      //   }
      //   addCloseButtonHandler(){
      //     const closeBtn = document.querySelector(`#${this.id} .close`);
      //     closeBtn.addEventListener('click', () => this.closeModal())
      //   }
      // }
      // const newModal = new Modal('block-modal', ['modal'], 'Hello World')
      // const openBtn = document.getElementById('myBtn');
      // openBtn.addEventListener('click',() => newModal.openModal())
      // newModal.render();
      
    </script>
  </body>
</html>
